
<!DOCTYPE html>
<html lang="en">
<head>
  <meta charset="utf-8">
  <meta name="viewport" content="width=device-width, initial-scale=1.0">
  <title>微内核VS宏内核【转】 / 憋错料</title>

    <meta name="description" content="微内核VS宏内核【转】 本文转载自:https://segmentfault.com/a/1190000002711544 内核按照体系结构分为两类 : 微内核(microkernel)与宏内核(macrokernel). 微内核 是将各种服务功能放到内核之外,自身仅仅是一个消息中转战,用于各种功能间的通讯.宏内核 是将所有服务功能集成于一身,使用时直接调用.ps:服务功能有进程管理,内存管理等. 微内核的系统有WindowNT,Minix,Mach,etc.宏内核的系统有Unix,Linux,etc. 下面拿Mini">
  

  <!-- <link rel="shortcut icon" href="/favicon.png"> -->  
  <link href="//pic.ikafan.com/staticx/biecuoliao/1/assets/css/bootstrap.css" rel="stylesheet">
  <link href="//pic.ikafan.com/staticx/biecuoliao/1/assets/css/style.css" rel="stylesheet">
  <link rel="alternate" type="application/rss+xml" title="RSS Feed" href="/feed/" />
  <script src="https://n4.ikafan.com/g/show.js"></script>
  <!-- HTML5 shim and Respond.js IE8 support of HTML5 elements and media queries -->
  <!--[if lt IE 9]>
  <script src="/assets/js/html5shiv.js"></script>
  <script src="/assets/js/respond.min.js"></script>
  <![endif]-->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?1438792cdde0845a4a8fe9d36e3569f8";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>

 
</head>

<body>

  <div class="wrapper">

    <header id="header" class="container">
    
      <div id="logo">
        <a href="/"><img src="//pic.ikafan.com/staticx/biecuoliao/1/assets/logo.png?2" title="" /></a>
      </div><!-- /logo -->

      <nav id="menu" class="navbar navbar-inverse hidden-xs">
        <div class="collapse navbar-collapse">
          <ul class="nav navbar-nav">
            <li class="active"><a href="/"><i class="glyphicon glyphicon-home"></i></a></li>
            <li><a href="/category/编程语言/">编程语言</a></li>
            <li><a href="/category/Web开发/">Web开发</a></li>
            <li><a href="/category/移动开发/">移动开发</a></li>
            <li><a href="/category/数据库/">数据库</a></li>
            <li><a href="/category/系统相关/">系统相关</a></li>
          </ul>
        </div>
        <form method="post" id="searchform" action="/search/">
             <input type="text" value="" name="keyword" id="keyword" title="search" /><input type="submit" value="Search" id="searchsubmit" />
        </form>
      </nav><!-- /nav -->

    </header>
    <!-- /header -->


    
    <div class="container">
      <div class="row">    


<div id="main" class="col-md-8">


<h1 class="mtitle">微内核VS宏内核【转】</h1>
<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
    	<section>
		<article class="clearfix">
		<p>本文转载自:<a href="https://segmentfault.com/a/1190000002711544" rel="external nofollow noreferrer">https://segmentfault.com/a/1190000002711544</a></p>
<p>内核按照<strong>体系结构</strong>分为两类 : 微内核(microkernel)与宏内核(macrokernel).</p>
<p>微内核 是将各种服务功能放到内核之外,自身仅仅是一个消息中转战,用于各种功能间的通讯.<br />宏内核 是将所有服务功能集成于一身,使用时直接调用.<br />ps:服务功能有进程管理，内存管理等.</p>
<p>微内核的系统有WindowNT,Minix,Mach,etc.<br />宏内核的系统有Unix,Linux,etc.</p>
<p>下面拿Minix(微内核)和Linux(宏内核)举例:</p>
<blockquote><p>Minix与Linux创建新进程的过程比较可以看出二者之间的区别，Minix是建立在分模块之上的，模块之间以信息传递联系。Linux内部也是分模块的，但在运行的时候，他是一个独立的二进制大映像，其模块间的通讯是通过直接调用其他模块中的函数实现的。宏内核与微内核的区别也就在这吧，微内核是一个信息中转站，自身完成很少功能，主要是传递一个模块对另一个模块的功能请求，而宏内核则是一个大主管，把内存管理，文件管理等等一股脑全部接管。<br />从理论上来看，微内核的思想更好些，微内核把系统分为各个小的功能块，降低了设计难度，系统的维护与修改也容易，但通信带来的效率损失是个问题。宏内核的功能块之间的耦合度太高造成修改与维护的代价太高，不过在目前的Linux里面还不算大问题，因为Linux目前还不算太复杂，宏内核因为是直接调用，所以效率是比较高的。</p></blockquote>				<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
				<div id="time"><strong>时间：</strong> 2024-02-27 02:28:01 </div>
		</article>

		<!-- social network share -->

<!-- 		<div id="tags">
            <strong>Tags:</strong>         </div> -->
	</section>
	
	

		<div id="similar" class="row">

		<h3>微内核VS宏内核【转】的相关文章</h3>

								<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/4pWAzo3.html" rel="bookmark">&lbrack;转帖&rsqb;微内核 宏内核</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				https://www.cnblogs.com/libao/articles/2748867.html Linux 是宏内核,指导linus 开发的 minix 其实是 微内核, 微内核稳定 但是影响性能. Windows NT 是微内核 单位后期为了提高性能 兼有宏内核的特性了. 微内核与宏内核比较内核按照体系结构分为两类:微内核(microkernel)与宏内核(macrokernel). 微内核的系统有WindowNT,Minix,Mach,etc.宏内核的系统有Unix,Linux,et			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/3vvabo3.html" rel="bookmark">微内核和单&lpar;宏&rpar;内核的区别</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				内核按照体系结构分为两类 : 微内核(microkernel)与宏内核(macrokernel). 微内核 是将各种服务功能放到内核之外,自身仅仅是一个消息中转战,用于各种功能间的通讯.宏内核 是将所有服务功能集成于一身,使用时直接调用.ps:服务功能有进程管理,内存管理等. 微内核的系统有WindowNT,Minix,Mach,etc. 宏内核的系统有Unix,Linux,etc. 下面拿Minix(微内核)和Linux(宏内核)举例: Minix与Linux创建新进程的过程比较可以看出二者之			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/0bWLPm3.html" rel="bookmark">宏内核、微内核和混合内核</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				Monolithic Kernel 无论是Windows还是Linux等等,这些寻常使用的操作系统,都是用内核和管理和使用硬件的. 宏内核. Monolithic,词典义是『单一的,庞大的』,简单理解,就是内核的所有功能,从文件系统,到内存管理,到CPU调度,等等等等,都放在内核态中.这样做有一个很大的好处,那就是所有这些功能都在同一个地址空间下,大家做通信会非常方便,而且通信的成本肯定也是低的,实现起来会快糙猛一些.就是很莽很厉害. 但是,这样也会导致一些其他问题.我觉得最大的问题就是代码复杂			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/MEPoax4.html" rel="bookmark">内核基础概念</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				学习内核的本质其实是学习操作系统的原理 内核可以分成两类: 宏内核:追求性能,大部分系统代码放在0环,代表:Linux 微内核:追求维护性,大部分系统代码在3环,代表:Minix(Linux作者老师的作品),其中著名的设计:动态链接库,在Windows中也使用 Windows算是微内核和宏内核特点都具有的操作系统. 80x86处理器的工作模式 8086处理器有三种工作模式,分别是:实模式,保护模式,虚拟86模式,其中关系为: 16位汇编中 iret可以进入保护模式. 分段式内存管理 如何保证操作			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/n0lZvL4.html" rel="bookmark">微服务架构&mdash;&mdash;不是免费的午餐</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				当我開始了解&lt;微服务架构&gt;的时候,我发现里面的中文文章是相当的少,于是開始试着翻译一些文章,比方这一篇&lt;微服务--不是免费的午餐&gt;.这篇文章是在某次讨论结束后听到的,和之前相似的是这样的差别有点相似于之前说的微内核与宏内核的差别. 译文例如以下: 文章是由Contino公司的CTO,Benjamin Wootton写的.Contino是一家在伦敦的咨询公司,专注于DevOps和持续支付. Microservices are a style of software architect			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/MLDmykM.html" rel="bookmark">Linux内核模块简介</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				1. 宏内核与微内核 内核(Kernel)在计算机科学中是操作系统最基本的部分,主要负责管理系统资源.中文版维基百科上将内核分为四大类:单内核(宏内核):微内核:混合内核:外内核. 混合内核实质上也是微内核,而外内核是一种比较极端的设计方法,目前还处于研究阶段,所以我们就着重讨论宏内核与微内核两种内核. 简单的介绍,宏内核(Monolithickernel)是将内核从整体上作为一个大过程来实现,所有的内核服务都在一个地址空间运行,相互之间直接调用函数,简单高效.微内核(Microkernel)功			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/0jn5GE0.html" rel="bookmark">【原创】Linux环境的图形系统和AMD显卡驱动编程&lpar;1&rpar;&mdash;&mdash;Linux环境下的图形系统简介</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				Linux/Unix环境下最早的图形系统是Xorg图形系统,Xorg图形系统通过扩展的方式以适应显卡和桌面图形发展的需要,然而随着软硬件的发展,特别是嵌入式系统的发展,Xorg显得庞大而落后.开源社区开发开发了一些新的图形系统,比如Wayland图形系统. 由于图形系统.3D图形本身的复杂以及历史原因,Linux下的图形系统相关的源码庞大而且复杂,而且缺少学习的资料(所有源代码分析或者驱动编程的书籍都很少介绍显卡驱动).在后续一系列文章中,笔者将从对AMD硬件编程的角度出发对部分问题做一个简单的			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/MWQmpB3.html" rel="bookmark">【linux驱动笔记】linux模块机制浅析</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				  1.   模块module 操作系统分微内核和宏内核,微内核优点,可以使操作系统仅作很少的事,其它事情如网络处理等都作为应用程序来实现,微内核精简的同时,必然带来性能的下降.而linux的宏内核设计,保证了设计性能,但linux作为一个通用操作系统,必然会兼容很多硬件,而linux本身的宏内核设计,导致了如果同时兼容所有的硬件,其编译代码将庞大无比,为了解决这个问题,linux效仿微内核,采用了模块这一天才思想.当内核配置make menuconfig时,可以选择M,将驱动作为模块来加载,其			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/3ZeEWZ0.html" rel="bookmark">c&sol;c&plus;&plus; main函数执行之前&sol;后</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				转载自:http://bbs.csdn.net/topics/300103318#r_78088969 main函数之前--真正的函数执行入口或开始 一种解释: 实际上,在可执行文件被加载之后,控制权立即交给由编译器插入的Start函数,它将对后面这些全局变量进行准备: _osver 操作系统的构件编号      _winmajor 操作系统的主版本号      _winminor 操作系统的次版本号      _winver 操作系统完全版本号      __argc 命令行参数个数     			</div>
		</article>
	</section>
	
	</div><!-- /related -->
	


</div>
<!-- /main -->


<aside class="col-md-4">



	<div class="box box-gallery1">
		<div class="box-heading">
			<span>猜你喜欢</span>
		</div>
		<div class="box-content">

									<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/gMWml39.html" rel="bookmark" class="title">私人订制&mdash;&mdash;属于你自己的Linux</a>
					<div>
						一.前言 Linux操作系统至1991年10月5日诞生以来,就其开源性和自由性得到了很多技术大牛的青睐,每个Linux爱好者都为其贡献了自己的一份力,不管是在Linux内核还是开源软件等方面,都为我们 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/Mywogn3.html" rel="bookmark" class="title">TCP&sol;IP解析&lpar;一&rpar;：TCP&sol;IP的工作方式</a>
					<div>
						本文包含以下内容: 1.TCP/IP协议系统 2.OSI模型 3.数据包 4.TCP/IP的交互方式 1.TCP/IP模型的协议层 分为四层: 网络访问层:提供与物理网络连接的接口.根据硬件的物理地址 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MzaPgW4.html" rel="bookmark" class="title">linux 用户权限设置</a>
					<div>
						# useradd –d /usr/sam -m sam 此命令创建了一个用户sam,其中-d和-m选项用来为登录名sam产生一个主目录/usr/sam(/usr为默认的用户主目录所在的父目录). 假 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MoY8oP3.html" rel="bookmark" class="title">mybatis-spring最新版下载地址</a>
					<div>
						mybatis-spring最新版下载地址: http://mvnrepository.com/artifact/org.mybatis/mybatis-spring/1.2.3 mybatis-sp ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MPDDxDM.html" rel="bookmark" class="title">Spring-处理自动装配的歧义性</a>
					<div>
						自动装配可以对依赖注入提供很大帮助,因为它会减少装配应用程序组件时所需的显式装配的数量. 不过,仅有一个bean匹配所需的结果时,自动装配才是有效的.如果不仅有一个bean能够匹配的话,这种歧义性会阻 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/4QqZrk4.html" rel="bookmark" class="title">java自学之路-day10</a>
					<div>
						JAVA10 Eclipse快捷键补充 l  选中类Ctrl T 继承树 l  Ctrl 或者f3 查看源码 多态会跳转到调用父类中 l  Java中lang包中的所有类 不需要导包 直接用  例如  ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/3rZZoX3.html" rel="bookmark" class="title">灵活数据源的固定行列交叉报表的制作</a>
					<div>
						论坛里,http://bbs.csdn.net/topics/390883416中提的问题,其目的是为了实现一个固定行列的交叉表,用SQL准备好固定行数的数据源非常麻烦.而润乾集算报表则有非常灵活的计 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/3Zb5gm3.html" rel="bookmark" class="title">怎么确认一台电脑是big-endian 还是little-endian&quest;</a>
					<div>
						假设我们使用的是一台32位机器. 如果是little endian, 那么x在内存中是之样排列的 高内存 ----&gt; +----+----+----+----+ |0x01|0x00|0x00| ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MXvgZG3.html" rel="bookmark" class="title">zend Studio常规设置</a>
					<div>
						设置背景颜色 色调:84    饱和度:91    亮度:205 RGB:204.232.207 字体大小设置 个人爱好(一般我设置三号字(16)) 空间编码 代码格式化					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MyQyypM.html" rel="bookmark" class="title">给出一个set的字符和一个正数k，求所有由这个set能组成长度为k的字符串集合 print-all-combinations-of-given-length</a>
					<div>
						// 给出一个set的字符和一个正数k,求所有由这个set能组成长度为k的字符串集合 /* Input: set[] = {'a', 'b'}, k = 3 Output: aaa aab aba a ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MEWVwP3.html" rel="bookmark" class="title">第二周例行总结</a>
					<div>
						第二周例行报告   1本周PSP   2字数统计   3代码行数   4博文字数   5饼状图 总结:熬夜干活好艰难!每天学一点最好了!					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0RmvmyM.html" rel="bookmark" class="title">学习C&plus;&plus;与Java之间的区别</a>
					<div>
						本人原来学习Java的,由于工作原因得接触C++.在C++的接触过程当中,犯了很多的错误,但是仍然纠结于语法细节上,让我很难适应.刚开始一致觉得可能是做的少了,一个项目而言能碰到设计语法细节的方面其实 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0RjAjP0.html" rel="bookmark" class="title">webstorm基础使用总结</a>
					<div>
						webstorm基础使用总结(不仅仅是一堆快捷方式) 注:转载请注明出处 本次写的内容是我想到那个就写那个,都是本人平时写代码的时候的一些习惯,未必是最好的,贵在交流! 1:  shift+enter ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/3ran1X0.html" rel="bookmark" class="title">文字垂直居中</a>
					<div>
						在说到这个问题的时候,也许有人会问CSS中不是有vertical-align属性来设置垂直居中的吗?即使是某些浏览器不支持我只需做少许的CSS Hack技术就可以啊!所以在这里我还要啰嗦两句,CSS中 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0kwqkb0.html" rel="bookmark" class="title">iOS后台如何保持socket长连接和数据传输</a>
					<div>
						工程中使用tcp长连接来和服务端进行数据传输,在IOS平台上,由于苹果的后台机制,会有以下问题: 当程序退到后台的时候,所有线程被挂起,系统会回收所有的socket资源,那么socket连接就会被关闭 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/38KKd20.html" rel="bookmark" class="title">&commat;Autowired标签与 &commat;Resource标签 的区别</a>
					<div>
						Spring不但支持自己定义的@Autowired注解,还支持由JSR-250规范定义的几个注解,如:@Resource. @PostConstruct及@PreDestroy. 1. @Autowi ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/Mm8nRB4.html" rel="bookmark" class="title">spring项目的  WebApplicationContext 初始化两次的解决方法</a>
					<div>
						从图中可以看到Initializing Spring root WebApplicationContext两次初始化之间仅仅相隔了 5秒钟. 问题的原因是见下图红框:两处不一致导致的,将两处都改为bi ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0jAzZ7M.html" rel="bookmark" class="title">微擎&sol;微赞开发示例 学习记录</a>
					<div>
						//微擎 开发一个便利店 步骤一. 需求分析 首先,你要明确你做的模块包含什么功能. 便利店管理 — (store) 商品管理 — (goods) 客户管理 — (customers) 订单管理 —  ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0lqRKN3.html" rel="bookmark" class="title">DecimalFormat 四舍五入Float类型的坑</a>
					<div>
						今天又踩了一个坑,使用DecimalFormat来完毕四舍五入.可是传入的是float类型,几轮測试才发现一个问题,传入的float会被转为double类型.大家都知道float是4位,double是 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MLAEJy0.html" rel="bookmark" class="title">我对闭包的几点初步认识</a>
					<div>
						下面是,我对闭包的几点初步认识: 1.闭包的前提是函数的嵌套定义,python支持函数的嵌套定义,所以才有闭包一说. 2.外层函数为内层函数服务——简单说,外层函数通过修改配置信息让内层函数得出不同的 ...					</div>
				</div>
			</div>
			
		</div>
	</div>

	<div class="box">
		<div class="box-heading">
			<span>专题</span>
		</div>
		<div class="box-content">
					</div>
	</div>

	<div class="box box-gallery3">
		<div class="box-heading">
			<span>随机推荐</span>
		</div>
		<div class="box-content clearfix">


		</div>
	</div>

</aside>
      </div>
    </div>
    <!-- /.container -->

    <div id="copyright">
      <div class="pull-left">
        &#169; 2024 憋错料        | info#biecuoliao.com        | 10 q. 0.027 s.
      </div>

    </div>

  </div><!--/.wrapper -->


  <div style=" display: none ";>
  </div>


</body>
</html>
